/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"
#include "vga4.h"

#include "font/8x8"

/**********TEMPORARY*******/
/* Put a character at x,y */   /* 2 page faults */
/**************************/
int GGIputc(ggi_visual *vis,int x,int y,char c)
{
	int height=8,i,w; volatile uchar *adr2;
	uchar *field,*adr,mask1,mask2,foo;

	if((x>VIS_FB_WIDTH(vis))||(y>VIS_FB_HEIGHT(vis)))return-1;
	field=font+((uchar)c<<3);
	w=VIS_FB_WIDTH(vis)>>3;
	adr=__localfb+y*w+(x>>3);
	if(y+8>VIS_FB_HEIGHT(vis)) height=VIS_FB_HEIGHT(vis)-y;
	if(!(x&7)){
		adr2=adr+((VIS_GC_BGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w)
			*adr2=0xff;
		adr2=adr+((VIS_GC_FGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w,field++) {
			foo=*adr2;*adr2=*field;
		}
	}else if(x+8>VIS_FB_WIDTH(vis)){
		mask1=(0xff>>(x&7));
		adr2=adr+((VIS_GC_BGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w) {
			foo=*adr2; *adr2=mask1;
		}
		adr2=adr+((VIS_GC_FGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w,field++) {
			foo=*adr2; *adr2=*field>>(x&7);
		}
	}else{
		mask1=(0xff>>(x&7));
		mask2=~(0xff>>(x&7));
		adr2=adr+((VIS_GC_BGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w) {
			foo=*adr2; *adr2=mask1;
			foo=adr2[1]; adr2[1]=mask2;
		}
		adr2=adr+((VIS_GC_FGCOLOR(vis)&0xF)<<16);
		for(i=height;i--;adr2+=w,field++) {
			foo=*adr2; *adr2=*field>>(x&7);
			foo=adr2[1];adr2[1]=*field<<(-x&7);
		}
	}
	return 0;
}


/****TEMPORARY*******/
/* graphical printf */   /* 2*n page faults */
/********************/
int GGIputs(ggi_visual *vis,int x,int y,const char *str)
{
	int rc=0;
	
	while(*str) {
		GGIputc(vis,x,y,*str++);
		rc++;
		if ((x+=8)>=VIS_FB_WIDTH(vis)) {
			x=0;y+=8;
		}
	}

	return rc;
}
